/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.services.document.test;

import java.io.File;
import java.io.FileInputStream;
import java.io.InputStream;

import org.exoplatform.container.PortalContainer;
import org.exoplatform.services.document.DocumentReaderService;
import org.exoplatform.test.BasicTestCase;
/**
 * Web, Oct 19, 2005 @
 * @author: Phung Hai Nam
 * @email: phunghainam@gmail.com
 */
public class TestDocumentReaderService extends BasicTestCase {

  DocumentReaderService service_;

  public TestDocumentReaderService(String name) {
    super(name);
  }

  public void setUp() throws Exception {
    PortalContainer pcontainer = PortalContainer.getInstance() ;
    service_ =
      (DocumentReaderService) pcontainer.getComponentInstanceOfType(DocumentReaderService.class) ;
  }

  public void testPDFDocumentReaderService() throws Exception {
    InputStream is = null;
    File f = new File("src/resources/test.pdf");
    is = new FileInputStream(f);
    String text = service_.getContentAsText("application/pdf", is);
    System.out.println(text);
  }

  public void testWordDocumentReaderService() throws Exception {
    InputStream is = null;
    File f = new File("src/resources/test.doc");
    is = new FileInputStream(f);
    String text = service_.getContentAsText("application/msword", is);
    System.out.println(text);
  }

  public void testPPTDocumentReaderService() throws Exception {
    InputStream is = null;
    File f = new File("src/resources/test.ppt");
    is = new FileInputStream(f);
    String text = service_.getContentAsText("application/powerpoint", is);
    System.out.println(text);
  }

  public void testExcelDocumentReaderService() throws Exception {
    InputStream is = null;
    File f = new File("src/resources/test.xls");
    is = new FileInputStream(f);
    String text = service_.getContentAsText("application/excel", is);
    System.out.println(text);
  }

  public void testHTMLDocumentReaderService() throws Exception {
    InputStream is = null;
    File f = new File("src/resources/test.html");
    is = new FileInputStream(f);
    String text = service_.getContentAsText("text/html", is);
    System.out.println(text);
  }

  public void testTextPlainDocumentReaderService() throws Exception {
    InputStream is = null;
    File f = new File("src/resources/test.txt");
    is = new FileInputStream(f);
    String text = service_.getContentAsText("text/plain", is);
    System.out.println(text);
  }
}
