/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.faces.core.validator;

import java.util.ResourceBundle;

import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.validator.Validator;
import javax.faces.validator.ValidatorException;

import org.exoplatform.faces.application.ExoFacesMessage;
import org.exoplatform.faces.core.Util;
import org.exoplatform.faces.core.component.UIForm;

/**
 * Created by The eXo Platform SARL
 * Author : Chung Nguyen
 *          nguyenchung136@yahoo.com
 * Jan 26, 2006
 */
public class NumberFormatValidator implements Validator {

  public void validate(FacesContext context,  UIComponent component, Object value) throws ValidatorException {
    ResourceBundle res =  Util.getApplicationResourceBundle()  ;
    if(component instanceof UIForm) {
      UIForm.StringField field = (UIForm.StringField) value ;
      String valueNum=field.getValue();
      try {
        int numFormat= Integer.parseInt(valueNum);
      } catch (NumberFormatException e) {
        field.setError(true);
        Object[] args = {field.getName(), field.getValue()} ;
        throw new ValidatorException(new ExoFacesMessage(res.getString("NumberFormatValidator.msg.invalid-limitAcess"), args)) ;
      }
    }
  }

}
