package org.exoplatform.velocity.directive;

import java.io.IOException;
import java.io.Writer;
import java.util.MissingResourceException;
import java.util.ResourceBundle;
import org.apache.velocity.context.InternalContextAdapter;
import org.apache.velocity.exception.MethodInvocationException;
import org.apache.velocity.exception.ParseErrorException;
import org.apache.velocity.exception.ResourceNotFoundException;
import org.apache.velocity.runtime.RuntimeServices;
import org.apache.velocity.runtime.directive.Directive;
import org.apache.velocity.runtime.parser.node.Node;
/**
 * @author Tuan Nguyen (tuan08@users.sourceforge.net)
 * @since March 3, 2005
 * @version $Id$
 */
public class Res extends Directive {
  public String getName()  {    return "res"; }        
  
  public int getType() {  return LINE; }        

  public void init(RuntimeServices rs, InternalContextAdapter context, Node node) throws Exception {
      super.init(rs, context, node);
  }

  public boolean render(InternalContextAdapter context,  Writer w, Node node)
  throws IOException,  MethodInvocationException, ResourceNotFoundException, ParseErrorException {
    String  resourceKey = (String)node.jjtGetChild(0).value(context);
    ResourceBundle  res = (ResourceBundle)context.get("res") ;
    try {
      w.write(res.getString(resourceKey)) ;
    } catch (MissingResourceException ex) {
      w.write("#res(\"" + resourceKey + "\")") ;
    }
    return true;
  }
}
