package org.exoplatform.velocity.directive;

import java.io.IOException;
import java.io.Writer;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.Collections;
import java.util.Enumeration;
import java.util.Iterator;
import java.util.List;

import org.apache.velocity.context.InternalContextAdapter;
import org.apache.velocity.exception.MethodInvocationException;
import org.apache.velocity.exception.ParseErrorException;
import org.apache.velocity.exception.ResourceNotFoundException;
import org.apache.velocity.runtime.RuntimeServices;
import org.apache.velocity.runtime.directive.Directive;
import org.apache.velocity.runtime.parser.node.Node;
/**
 * @author Tuan Nguyen (tuan08@users.sourceforge.net)
 * @since March 3, 2005
 * @version $Id$
 */
public class TR extends Directive {
  
  public String getName()  {    return "tr"; }        
  public int getType() {  return BLOCK; }        
  
  public void init(RuntimeServices rs, InternalContextAdapter context, Node node) throws Exception {
    super.init(rs, context, node);
  }
  
  public boolean render(InternalContextAdapter context,  Writer w, Node node)
  throws IOException,  MethodInvocationException, ResourceNotFoundException, ParseErrorException {
    Object listObject = node.jjtGetChild(0).value(context);
    if (listObject == null)   return false;
    Iterator i = null;
    if(listObject instanceof Collection) { 
      i = ((Collection)listObject).iterator() ;
    } else if(listObject instanceof Iterator) {
      i = (Iterator) listObject ;
    } else if(listObject instanceof Object[]) {
      Collection col = new ArrayList();
      Object[] array = (Object[]) listObject;
      List list = Arrays.asList(array);
      col.addAll(list);
      i = col.iterator();
    }
    if (i != null)  {
      boolean even = true ;
      while (i.hasNext()) {        
        context.put("bean",i.next());
        if(even)  w.write("<tr class='even'>") ;
        else w.write("<tr class='odd'>") ;
        node.jjtGetChild(1).render(context, w);
        w.write("</tr>") ;
        even = !even ;
      }
      return true;
    }
    
    if(listObject instanceof Enumeration) { 
      Enumeration e = (Enumeration) listObject ;
      boolean even = true ;
      while(e.hasMoreElements()) {
        context.put("bean",e.nextElement());
        if(even)  w.write("<tr class='even'>") ;
        else w.write("<tr class='odd'>") ;
        node.jjtGetChild(1).render(context, w);
        w.write("</tr>") ;
        even = !even ;
      }
    }
    return false ;
  }
}