/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portal.faces.component;


import org.exoplatform.container.component.ExecutionContext;
import org.exoplatform.services.portal.log.PortalActivitiesLogService;

/**
 * Created by The eXo Platform SARL
 * Author : Tuan Nguyen
 *          tuan08@users.sourceforge.net
 * Sep 19, 2005
 */
public class UIComponentRenderStatisticCommand extends  UIComponentRenderCommand {
  private PortalActivitiesLogService service_ ;
  
  public UIComponentRenderStatisticCommand(PortalActivitiesLogService service) {
    service_ = service ;
  }
  
  public Object execute(ExecutionContext executionContext) throws Throwable {
    CommandExecutionContext context = (CommandExecutionContext)  executionContext ;
    long start = System.currentTimeMillis() ;
    context.executeNextUnit() ;
    long time = System.currentTimeMillis() -  start ;
    if(context.uicomponent instanceof UIPortlet) {
      UIPortlet uiPortlet = (UIPortlet) context.uicomponent ;
      String appId = uiPortlet.getWindowId().getPortletApplicationName();
      String portletId = uiPortlet.getWindowId().getPortletName() ;
      service_.logPortletRender(portletId, appId, time, false, "render") ;  
    } else if(context.uicomponent instanceof UIPage) {
      UIPage uiPage = (UIPage) context.uicomponent ;
      if(uiPage.hasError()) {
//        S ystem.out.println("PAGE HAS ERROR : " +  uiPage.getError()) ;
      } else {
        service_.logPageAccess(uiPage.getPageModel().getPageId(), uiPage.getOwner(),time, false) ;
      }
    } else if(context.uicomponent instanceof UIPortal) {
      UIPortal uiPortal = (UIPortal) context.uicomponent ;
      service_.logPortalAccess( uiPortal.getId(),uiPortal.getOwner(), time, false, false) ;
    }
    return null ;
  }
}