/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portal.faces.renderer.html.container;

import java.io.IOException;
import java.util.ResourceBundle;

import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.context.ResponseWriter;

import org.apache.velocity.Template;
import org.apache.velocity.VelocityContext;
import org.exoplatform.container.SessionContainer;
import org.exoplatform.faces.core.component.UIExoComponent;
import org.exoplatform.portal.PortalConstants;
import org.exoplatform.portal.faces.component.UIContainer;
import org.exoplatform.portal.faces.component.UIPortalComponent;
import org.exoplatform.portal.faces.renderer.BaseRenderer;
import org.exoplatform.portal.session.ExoPortal;
import org.exoplatform.services.log.LogUtil;
/**
 * Date: Aug 11, 2003
 * @author : Mestrallet Benjamin
 * @email:   benjmestrallet@users.sourceforge.net
 * @author: Tuan Nguyen
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id: ContainerRenderer.java,v 1.7 2004/09/21 03:41:34 tuan08 Exp $
 */
public class ContainerRenderer extends BaseRenderer {
  public void encodeChildren( FacesContext context, UIComponent component ) throws IOException {  
   
    ResponseWriter w = context.getResponseWriter() ;
    ResourceBundle res = getApplicationResourceBundle(context.getExternalContext());
    UIContainer uicontainer = (UIContainer) component ;    
    try {
      VelocityContext vcontext = new VelocityContext() ;
      vcontext.put(UIExoComponent.UICOMPONENT, uicontainer) ;
      vcontext.put("res", res) ;
      vcontext.put("renderer", this) ;
      vcontext.put("context", context) ;
      vcontext.put("componentId", uicontainer.getId()) ;
      vcontext.put("model", uicontainer.getComponentModel()) ;
      if(uicontainer.getMode() == UIPortalComponent.COMPONENT_EDIT_MODE) {
        vcontext.put("mode", "edit") ;
        vcontext.put("addPortletParams", PortalConstants.addPortletParams);
        vcontext.put("addContainerParams", PortalConstants.addContainerParams);
        vcontext.put("editParams", PortalConstants.editParams);
        vcontext.put("deleteParams", PortalConstants.deleteParams);
        if(uicontainer.getFloat() == UIPortalComponent.FLOAT_BOTTOM) { 
          vcontext.put("float", "bottom") ;
          vcontext.put("moveUpParams",   PortalConstants.moveUpParams);
          vcontext.put("moveDownParams", PortalConstants.moveDownParams);
        } else {
          vcontext.put("float", "right") ;
          vcontext.put("moveLeftParams",  PortalConstants.moveUpParams);
          vcontext.put("moveRightParams", PortalConstants.moveDownParams);
        }
        ExoPortal portal = (ExoPortal)SessionContainer.getComponent(ExoPortal.class) ;        
        if(portal.getPortalMode() != ExoPortal.PORTAL_EDIT_PAGE_MODE) {
          vcontext.put("placeBodyParams", PortalConstants.placeBodyParams);
        }
      } else {
        vcontext.put("mode", "view") ;
      }      
      Template template = getTemplate(component, context) ;     
      template.merge(vcontext, w) ;
    } catch (Exception ex) {
      LogUtil.getLog(getClass()).error("Render  Error: ", ex) ;
    }
  }
}