/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.content.display.component;

import java.util.Enumeration;
import java.util.List;

import javax.portlet.PortletPreferences;

import org.exoplatform.container.PortalContainer;
import org.exoplatform.container.SessionContainer;
import org.exoplatform.faces.FacesUtil;
import org.exoplatform.faces.core.component.UIExoCommand;
import org.exoplatform.portal.session.PortalResources;
import org.exoplatform.services.idgenerator.IDGeneratorService;
import org.exoplatform.services.portal.content.DocumentContent;
import org.exoplatform.services.portal.content.PortalContentService;

/**
 * Created by The eXo Platform SARL
 * Author : Pham Xuan Hoa
 *          phamvuxuanhoa@yahoo.com
 * Mar 2, 2006
 */
public class UIContentConfig extends UIExoCommand{
	final static public String[] DEFAULT_VALUES = {"id=" };
	
	protected PortalContentService contentService_ ;
	protected IDGeneratorService generatorService_ ;
	protected DocumentContent dContent_ ;
	
	public UIContentConfig(UIContentConfigForm configForm) throws Exception{
		contentService_ = (PortalContentService)PortalContainer.getComponent(PortalContentService.class) ;
		generatorService_ = (IDGeneratorService)PortalContainer.getComponent(IDGeneratorService.class) ;    
		setRendererType("ChildrenRenderer");   
		setId("UIContentConfig");    
		dContent_ = getDocumentContent() ;
		configForm.setContentConfig(dContent_) ;
		configForm.setRendered(true) ;
		List children = getChildren();
		children.add(configForm) ;
	}  
	
	private DocumentContent getDocumentContent() throws Exception{
		PortletPreferences prefs = FacesUtil.getPortletPreferences() ;
		Enumeration e = prefs.getNames();
		DocumentContent documentContent= null ;
		String id = null ;
		while (e.hasMoreElements()) {
			String name = (String) e.nextElement();      
			String[] values = prefs.getValues(name, DEFAULT_VALUES);
			try {        
				id = values[0].split("=")[1] ;
			}catch (Exception ex) {}
		}
		if(id == null) return null ;		
		if(id.startsWith("war:")||id.startsWith("file://")) {
			if(id.endsWith(".html")) {			
				documentContent = null ;
				documentContent = contentService_.getDocumentById(id) ;
				return documentContent ;
			}            	    			
			PortalResources res = (PortalResources)SessionContainer.getComponent(PortalResources.class);
			String lang = res.getLocaleConfig().getLanguage() ;
			List<DocumentContent> list = contentService_.getDocumentsByGroupId(id) ;
			String tmp = id+"_"+lang+".html" ;		
			for(DocumentContent content:list) {			
				if(content.getId().equals(tmp)) {
					documentContent = content ;				
				}
			}
			if(documentContent == null) {
				tmp = id+"_en.html" ;
				documentContent = contentService_.getDocumentById(tmp) ;
			}				
			return documentContent ;
		}				
		documentContent = contentService_.getDocumentById(id) ;
		return documentContent ;
	}
	
	public void saveContentConfig(DocumentContent documentContent) throws Exception {    		
		PortletPreferences prefs = FacesUtil.getPortletPreferences() ;
		Enumeration e = prefs.getNames();    
		contentService_.save(documentContent) ;
		String name=null ;
		while (e.hasMoreElements()) {
			name = (String) e.nextElement();                                             
		}
		String [] values = new String[1] ;
		values[0] = "id="+documentContent.getId() ;
		prefs.setValues(name,values) ;
		prefs.store() ;    
	}	
}
