package org.esupportail.cas.server.handlers.database;

import org.dom4j.Element;

/**
 * This class implements a search database handler class. It is used by
 * GenericHandler.
 *
 * @author Pascal Aubry <pascal.aubry at univ-rennes1.fr>
 */
public final class SearchDatabaseHandler extends QueryDatabaseHandler {
		
	/**
	 * Constructor.
	 *
	 * @param handlerElement the XML element that declares the handler 
	 * in the configuration file
	 * @param configDebug debugging mode of the global configuration
	 * @throws Exception Exception
	 */
	public SearchDatabaseHandler(
			final Element handlerElement, 
			final Boolean configDebug) throws Exception {
		super(handlerElement, configDebug);
		traceBegin();
		traceEnd();
	}
	
	/**
	 * Read the SQL query from the configuration (deduces it from other parameters).
	 * @return a String.
	 * @throws Exception Exception
	 */
	protected String readSqlQueryFromConfig() throws Exception {
		traceBegin();
		
		String table = getConfigSubElementContent("table", true/*needed*/);
		trace("table = " + table);
		
		String loginColumn = getConfigSubElementContent("login_column", true/*needed*/);
		trace("login_column = " + loginColumn);

		String passwordColumn = getConfigSubElementContent("password_column", true/*needed*/);
		trace("password_column = " + passwordColumn);

		String query = "SELECT " + passwordColumn 
		+ " FROM " + table 
		+ " WHERE " + loginColumn 
		+ " = '" + QueryDatabaseHandler.SQL_LOGIN_TOKEN + "'";

		traceEnd(query);
		return query;
	}
	
}

