/***************************************************************************
 * Copyright 2001-2005 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package condition ;

import com.meterware.httpunit.*;
import org.exoplatform.test.web.ExoWebClient;
import org.exoplatform.test.web.condition.Condition;

/**
 * May 21, 2004
 * @author: Dung Hoang
 * @email:   jobdung@yahoo.com
 * @version: $Id: HaveLinkWithTextCondition.groovy,v 1.1 2005/12/21 2:38:04 dunghoang Exp $
 **/
public class HaveLinkWithTextCondition implements Condition {
  private String text_ ;
  private int suiteStatus_ ;
  
  public HaveLinkWithTextCondition(String text) {
    text_ = text ;
    suiteStatus_ = -1 ;
  }
  
  public HaveLinkWithTextCondition(String text, int status) {
    text_ = text ;
    suiteStatus_ = status ;
  }
  
  public boolean checkCondition(WebResponse response, WebTable block, ExoWebClient client){
    WebLink link = response.getLinkWith(text_) ;
    boolean test = link != null ;
    if(test == false && suiteStatus_ >= 0) {
      client.getTestSuites().getCurrentWebUnitSuite().setStatus(suiteStatus_) ;
    }
    return test ;
  }
  
  public String getName() { return "HaveLinkWithTextCondition" ; }
  public String getDescription() {
    return "This unit test should run only if the previous return response has the the text" ;
  }
}