/***************************************************************************
 * Copyright 2001-2005 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package suites.ecm.user;

import condition.* ;
import suites.share.* ;
import org.exoplatform.test.web.*;
import org.exoplatform.test.web.unit.*;
import org.exoplatform.test.web.validator.*;
/**
 * Created by The eXo Platform SARL
 * Author : Dung Hoang
 *          dunghoang@exoplatform.com, jobdung@yahoo.com
 * Dec 27, 2005
 */
public class UserManageCategoriesSuite extends WebUnitSuite {
  static String DESC = "Go to Ecm Portlet User page, click on Info tab, click on Manage Categories button and to do somethings" ;
  static String NAME = "UserManageCategoriesSuite" ;
  String COMMENT  = "You must run AdminManageTaxonomySuite and AdminViewSuite and PortletRegistrySuite before run this suite";
  
  public UserManageCategoriesSuite() {    
    super(NAME, DESC) ;    
    addWebUnit(
        new ClickLinkWithText("ClickOnHome", "Go to home").
        setTextLink("Home").
        addValidator(new ExpectLinkWithURLValidator("windowState=minimized"))
    ) ;   
    addWebUnit(CommonUnit.CLICK_EDIT_PAGE_MODE) ;
    addWebUnit(
        new ClickURLLinkUnit("ClickOnAddPortlet", "Click on Add Portlet icon").
        setURL("portal:componentId=news&portal:action=addPortlet").                  
        addValidator(new ExpectLinkWithURLValidator("uicomponent=UIPortletSelecttor&op=selecCategory&objectId=cms-content"))
    ) ;
    addWebUnit(
        new ClickURLLinkUnit("ClickOn'cms-content'category", "Expand Cms-Content category").
        setURL("uicomponent=UIPortletSelecttor&op=selecCategory&objectId=cms-content").      
        addCondition(new NoLinkWithURLCondition("uicomponent=UIPortletSelecttor&op=selecPortlet&objectId=cms-content/CategoryBrowser")).
        addValidator(new ExpectTextValidator("CategoryBrowser"))
    ) ;           
    //-----Selete a portlet in expanded content category
    addWebUnit(
        new ClickURLLinkUnit("CategoryBrowser'portlet", "Select the Category Browser portlet").      
        setURL("uicomponent=UIPortletSelecttor&op=selecPortlet&objectId=cms-content/CategoryBrowser").
        addValidator(new ExpectLinkWithURLValidator("portal:componentId=news&portal:action=changeTab&objectId=CategoryBrowser"))        
    ) ;
    addWebUnit(
        new ClickURLLinkUnit("ClickViewMode", "Click on View Mode icon").
        setURL("uicomponent=UIToolbarPage&op=changeMode&mode=normal").                  
        addValidator(new ExpectLinkWithURLValidator("portal:componentId=news&portal:action=changeTab&objectId=CategoryBrowser"))
    ) ; 
    addWebUnit(
        new ClickURLLinkUnit("ClickCategoryBrowser", "Click on CategoryBrowse tab").
        setURL("portal:componentId=news&portal:action=changeTab&objectId=CategoryBrowser").                  
        addValidator(new ExpectLinkWithURLValidator("uicomponent=UICategoryList&op=viewCategory&objectId=/jcr:system/exo:ecm/exo:taxonomies/newCategory"))
    ) ;  
    addWebUnit(
        new ClickURLLinkUnit("ClickOnnewCategory", "Click on newCategory").
        setURL("uicomponent=UICategoryList&op=viewCategory&objectId=/jcr:system/exo:ecm/exo:taxonomies/newCategory").                  
        addValidator(new ExpectLinkWithURLValidator("uicomponent=UICategoryList&op=viewCategory&objectId=/jcr:system/exo:ecm/exo:taxonomies/newCategory/childCategory"))
    ) ;  
    addWebUnit(
        new ClickURLLinkUnit("ClickOnchildCategory", "Click on childCategory").
        setURL("uicomponent=UICategoryList&op=viewCategory&objectId=/jcr:system/exo:ecm/exo:taxonomies/newCategory/childCategory").                  
        addValidator(new ExpectTextValidator("No article in this category"))
    ) ;  
    addWebSuite(new UserAddFolderSuite());        
    //Select Actions tab
    addWebUnit(
      new ClickURLLinkUnit("SelectActiontab", "Select Actions tab").
      setURL("&uicomponent=UIViewController&op=selectNode&objectId=Actions").                  
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIToolbar&op=addFolder"))      
    ) ;
    //Click on Add document
    addWebUnit(
      new ClickURLLinkUnit("AddDocument", "click on Add Document button").
      setURL("uicomponent=UIToolbar&op=addDocument").    
      addValidator(new ExpectFormIdValidator("selectDocumentForm")).
      addValidator(new ExpectFormIdValidator("documentForm"))
    ) ;
    //-----Add new Nt:file document
    addWebUnit(
      new SubmitFormUnit("SelectDocumentType", "select document type is nt:file").
      setFormId("selectDocumentForm").   
      setField("documentType","nt:file").
      setField("op","changeDocument").
      addValidator(new ExpectNoTextValidator("Image to upload")).
      addValidator(new ExpectTextValidator("File")).
      addValidator(new ExpectTextValidator("Content:"))
    ) ;
    //----------Save New Document
    addWebUnit(
      new SubmitFormUnit("SaveNewDocument", "click on save button").
      setFormId("documentForm").   
      setField("docName","test-doc").
      setField("summary","content").      
      setField("op","save").
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIDocumentInfo&op=editDocument&objectId=test-doc"))
    ) ;                
    //Save session
    addWebUnit(
      new ClickURLLinkUnit("SavedSession", "click on save Session button").
      setURL("&uicomponent=MainToolbar&op=saveSession").        
      addValidator(new ExpectTextValidator("All the changes have been saved"))      
    ) ;
    addWebUnit(
        new ClickURLLinkUnit("GotoTest-doc", "click on test-doc").
        setURL("uicomponent=UIDocumentInfo&op=changeNode&objectId=/home/users/#{client.name}/test-folder/test-doc").         
        addValidator(new ExpectTextValidator("test-doc"))
    ) ;
    //-----Select Admin tab
    addWebUnit(
      new ClickURLLinkUnit("SelectAdminTab", "Select Admin tab").
      setURL("&uicomponent=UIViewController&op=selectNode&objectId=Admin").             
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIToolbar&op=manageVersions")).      
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIToolbar&op=manageCategories")).
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIToolbar&op=manageActions")).      
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIToolbar&op=exportNode")).
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIToolbar&op=importNode"))
    ) ;   
    //-----Manage Category
    addWebUnit(
        new ClickURLLinkUnit("ClickOnManageCategory", "Click on Manage Category icon").
        setURL("uicomponent=UIToolbar&op=manageCategories").                  
        addValidator(new ExpectLinkWithURLValidator("&uicomponent=UICategoriesList&op=add"))
    ) ;
    addWebUnit(
        new ClickURLLinkUnit("ClickAddCategory", "Click on Add Category icon").
        setURL("&uicomponent=UICategoriesList&op=add").                  
        addValidator(new ExpectLinkWithURLValidator("uicomponent=JcrCategoryBrowser&op=changeNode&objectId=/jcr:system/exo:ecm/exo:taxonomies/newCategory"))
    ) ;
    addWebUnit(
        new ClickURLLinkUnit("ClicknewCategory", "Click on newCategory").
        setURL("uicomponent=JcrCategoryBrowser&op=changeNode&objectId=/jcr:system/exo:ecm/exo:taxonomies/newCategory").                  
        addValidator(new ExpectLinkWithURLValidator("uicomponent=JcrCategoryBrowser&op=selectNode&objectId=/jcr:system/exo:ecm/exo:taxonomies/newCategory/childCategory"))
    ) ;
    addWebUnit(
        new ClickURLLinkUnit("SelectchildCategory", "Select childCategory").
        setURL("uicomponent=JcrCategoryBrowser&op=selectNode&objectId=/jcr:system/exo:ecm/exo:taxonomies/newCategory/childCategory").                  
        addValidator(new ExpectTextValidator("/jcr:system/exo:ecm/exo:taxonomies/newCategory/childCategory"))
    ) ;
    addWebUnit(
        new ClickURLLinkUnit("DeletechildCategory", "Click on delete icon of childCategory").
        setURL("uicomponent=UICategoriesList&op=delete&objectId=/jcr:system/exo:ecm/exo:taxonomies/newCategory/childCategory").                  
        addValidator(new ExpectNoTextValidator("/jcr:system/exo:ecm/exo:taxonomies/newCategory/childCategory")).
        addValidator(new ExpectLinkWithURLValidator("&uicomponent=UICategoriesList&op=add"))
    ) ;
    addWebUnit(
        new ClickURLLinkUnit("ClickAddCategory", "Click on Add Category icon").
        setURL("&uicomponent=UICategoriesList&op=add").                  
        addValidator(new ExpectLinkWithURLValidator("uicomponent=JcrCategoryBrowser&op=changeNode&objectId=/jcr:system/exo:ecm/exo:taxonomies/newCategory"))
    ) ;
    addWebUnit(
        new ClickURLLinkUnit("ClicknewCategory", "Click on newCategory").
        setURL("uicomponent=JcrCategoryBrowser&op=changeNode&objectId=/jcr:system/exo:ecm/exo:taxonomies/newCategory").                  
        addValidator(new ExpectLinkWithURLValidator("uicomponent=JcrCategoryBrowser&op=selectNode&objectId=/jcr:system/exo:ecm/exo:taxonomies/newCategory/childCategory"))
    ) ;
    addWebUnit(
        new ClickURLLinkUnit("SelectchildCategory", "Select childCategory").
        setURL("uicomponent=JcrCategoryBrowser&op=selectNode&objectId=/jcr:system/exo:ecm/exo:taxonomies/newCategory/childCategory").                  
        addValidator(new ExpectTextValidator("/jcr:system/exo:ecm/exo:taxonomies/newCategory/childCategory")).
        addValidator(new ExpectLinkWithURLValidator("uicomponent=UICategoriesList&op=PhaseId[1].cancel"))
    ) ;
    //-----Save session
    addWebUnit(
      new ClickURLLinkUnit("SavedSession", "click on save Session button").
      setURL("&uicomponent=MainToolbar&op=saveSession").        
      addValidator(new ExpectTextValidator("All the changes have been saved"))      
    ) ;   
    //-----Refresh session
    addWebUnit(
      new ClickURLLinkUnit("RefreshSession", "click on Refresh Session button").
      setURL("&uicomponent=MainToolbar&op=refreshSession").  
      addValidator(new ExpectTextValidator("The session has been refreshed successfuly"))      
    ) ; 
    addWebUnit(
        new ClickURLLinkUnit("ClickOnBack", "Go back to ").
        setURL("uicomponent=UICategoriesList&op=PhaseId[1].cancel").                  
        addValidator(new ExpectNoTextValidator("/jcr:system/exo:ecm/exo:taxonomies/newCategory/childCategory"))
    ) ;
    addWebUnit(
        new ClickURLLinkUnit("SelectWorkspace", "Go to workspace ").
        setURL("uicomponent=MainToolbar&op=selectWorkspace").                  
        addValidator(new ExpectTextValidator("Workspaces"))
    ) ;   
    addWebUnit(
        new ClickLinkWithText("ClickOnHome", "Go to home").
        setTextLink("Home").
        addValidator(new ExpectLinkWithURLValidator("windowState=minimized"))
    ) ;   
    addWebUnit(
        new ClickURLLinkUnit("ClickOnchildCategory", "Click on childCategory").
        setURL("uicomponent=UICategoryList&op=viewCategory&objectId=/jcr:system/exo:ecm/exo:taxonomies/newCategory/childCategory").                  
        addValidator(new ExpectLinkWithURLValidator("uicomponent=UICategoryList&op=viewDocument&objectId=production:/home/users/#{client.name}/test-folder/test-doc"))
    ) ; 
    addWebUnit(
        new ClickURLLinkUnit("ClickOntestdoc", "Click on test-doc").
        setURL("uicomponent=UICategoryList&op=viewDocument&objectId=production:/home/users/#{client.name}/test-folder/test-doc").                  
        addValidator(new ExpectTextValidator("content"))
    ) ; 
    addWebUnit(
        new ClickLinkWithText("ClickOnECM", "Go to ECM").
        setTextLink("ECM").
        addValidator(new ExpectTextValidator("Workspaces"))
    ) ; 
  }                 
  public java.util.List getRequiredSuites() { 
    String[] roles = ["user"] ;
    return [new NewAccountSuite(), new UserLoginSuite("#{client.name}", "#{client.name}", roles)] ;
  }  
}