/***************************************************************************
 * Copyright 2001-2005 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package suites.ecm.user;

import condition.* ;
import suites.share.* ;
import org.exoplatform.test.web.*;
import org.exoplatform.test.web.unit.*;
import org.exoplatform.test.web.validator.*;

/**
 * Created by The eXo Platform SARL
 * Author : Hoa Nguyen Thi
 *          hoa2501@yahoo.com
 * Mar 17, 2006
 */
public class UserSearchSuite extends WebUnitSuite {
  static String DESC = "Go to Search of Production on ECM and test  basic actions " ;
  static String NAME = "UserSearchSuite" ;
  String COMMENT=null;
  
  public UserSearchSuite() {    
    super(NAME, DESC) ;        
    goToPage("/Site Map/ecm") ;
    addWebUnit(
        new ClickURLLinkUnit("ClickOnProduction", "click on Production button").
        setURL("&uicomponent=UIWorkspaceBrowser&op=selectWorkspace&objectId=production").                  
        addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIViewController&op=selectNode&objectId=Actions"))   
     ) ;
    //Go to Actions Tab
    addWebUnit(
        new ClickURLLinkUnit("ClickOnActionsTab", "click on Actions Tab").
        setURL("&uicomponent=UIViewController&op=selectNode&objectId=Actions").                  
        addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIToolbar&op=search"))      
    ) ;
    //Go to Search and test basic action
    addWebUnit(
        new ClickURLLinkUnit("ClickOnSearchIcon", "click on Actions Tab").
        setURL("&uicomponent=UIToolbar&op=search").                  
        addValidator(new ExpectLinkWithURLValidator("&uicomponent=UISearch&op=selectNode&objectId=UISimpleSearch")).
        addValidator(new ExpectLinkWithURLValidator("&uicomponent=UISearch&op=selectNode&objectId=UIJCRAdvancedSearch")).
        addValidator(new ExpectLinkWithURLValidator("&uicomponent=UISearch&op=selectNode&objectId=UIQueryList")).
        addValidator(new ExpectLinkWithURLValidator("&uicomponent=UISearch&op=selectNode&objectId=UIResults"))
    ) ;
    //-----Search with words
    addWebUnit(
        new ClickURLLinkUnit("SimpleSearch", "Click on  Simple Search button and search with any work").
        setURL("&uicomponent=UISearch&op=selectNode&objectId=UISimpleSearch").                 
        addValidator(new ExpectFormIdValidator("UISimpleSearch"))
    ) ; 
    addWebUnit(
        new SubmitFormUnit("ClickOnCancel", "Don't simple search ").
        setFormId("UISimpleSearch").   
        setField("op","PhaseId[1].cancel").
        addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIToolbar&op=search"))      
    ) ;  
    addWebUnit(
        new ClickURLLinkUnit("ClickOnSearchIcon", "Click on Actions Tab").
        setURL("&uicomponent=UIToolbar&op=search").                  
        addValidator(new ExpectLinkWithURLValidator("&uicomponent=UISearch&op=selectNode&objectId=UISimpleSearch")).
        addValidator(new ExpectLinkWithURLValidator("&uicomponent=UISearch&op=selectNode&objectId=UIJCRAdvancedSearch")).
        addValidator(new ExpectLinkWithURLValidator("&uicomponent=UISearch&op=selectNode&objectId=UIQueryList")).
        addValidator(new ExpectLinkWithURLValidator("&uicomponent=UISearch&op=selectNode&objectId=UIResults"))
    ) ;    
    addWebUnit(
        new ClickURLLinkUnit("SimpleSearch", "Click on  Simple Search button and search with any work").
        setURL("&uicomponent=UISearch&op=selectNode&objectId=UISimpleSearch").                 
        addValidator(new ExpectFormIdValidator("UISimpleSearch"))
    ) ; 
    addWebUnit(
        new SubmitFormUnit("SearchBlankWorks", "Search with blank work properties").
        setFormId("UISimpleSearch").   
        setField("text","").
        setField("op","searchAction").
        addValidator(new ExpectTextValidator("A Repository Exception occured."))      
    ) ;
    addWebUnit(
        new SubmitFormUnit("SearchWorks", "Search with work properties is 'backup'").
        setFormId("UISimpleSearch").   
        setField("text","backup").
        setField("op","searchAction").
        addValidator(new ExpectTextValidator("backup"))      
    ) ;  
    //-----Search with query
    addWebUnit(
        new ClickURLLinkUnit("NewQuery", "Click on  New Query button to advanced search by Query language  sql or xpath").
        setURL("&uicomponent=UISearch&op=selectNode&objectId=UIJCRAdvancedSearch").                 
        addValidator(new ExpectFormIdValidator("UIJCRAdvancedSearch"))
    ) ; 
    addWebUnit(
        new SubmitFormUnit("SearchBySQL", "Search with Query language  sql").
        setFormId("UIJCRAdvancedSearch").   
        setField("select","sql").
        setField("query","select * from nt:base where jcr:path like '/cms/%'").
        setField("op","searchAction").
        addValidator(new ExpectTextValidator("/cms")).  
        addValidator(new ExpectLinkWithURLValidator("uicomponent=UISearch&op=selectNode&objectId=UIQueryList"))
    ) ; 
    addWebUnit(
        new ClickURLLinkUnit("NewQuery", "Click on  New Query button to advanced search by Query language  sql").
        setURL("&uicomponent=UISearch&op=selectNode&objectId=UIJCRAdvancedSearch").                 
        addValidator(new ExpectFormIdValidator("UIJCRAdvancedSearch"))
    ) ; 
    addWebUnit(
        new SubmitFormUnit("SaveSearchBySQL", "Save result search by Query language  sql").
        setFormId("UIJCRAdvancedSearch").
        setField("name","SearchBySQLTest").
        setField("select","sql").
        setField("query","select * from nt:base where jcr:path like '/cms/%'").
        setField("op","save").
        addValidator(new ExpectTextValidator("The query has been added")).  
        addValidator(new ExpectLinkWithURLValidator("uicomponent=UISearch&op=selectNode&objectId=UIQueryList"))
    ) ; 
    addWebUnit(
        new ClickURLLinkUnit("CheckStatusSavedSQL", "Click on  Save Queries button to check status of action save search result by Query language  sql").
        setURL("uicomponent=UISearch&op=selectNode&objectId=UIQueryList").                 
        addValidator(new ExpectTextValidator("select * from nt:base where jcr:path like '/cms/%'")).
        addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIQueryList&op=execute&objectId=/home/users/#{client.name}/queries/SearchBySQLTest"))                 
    ) ; 
    addWebUnit(
        new ClickURLLinkUnit("CheckResultSavedSQL", "Click on  Save Queries button to check result of action save search result by Query language  sql").
        setURL("uicomponent=UIQueryList&op=execute&objectId=/home/users/#{client.name}/queries/SearchBySQL").                 
        addValidator(new ExpectLinkWithURLValidator("&uicomponent=UISearch&op=selectNode&objectId=UIJCRAdvancedSearch")).
        addValidator(new ExpectTextValidator("/cms"))
    ) ; 
    addWebUnit(
        new ClickURLLinkUnit("NewQuery", "Click on  New Query button to advanced search by Query language  sql").
        setURL("&uicomponent=UISearch&op=selectNode&objectId=UIJCRAdvancedSearch").                 
        addValidator(new ExpectFormIdValidator("UIJCRAdvancedSearch"))
    ) ; 
    addWebUnit(
        new SubmitFormUnit("SearchByXPathEmpty", "Search by Query language  xpath with query properties is empty").
        setFormId("UIJCRAdvancedSearch").  
        setField("select","xpath").
        setField("query","").
        setField("op","searchAction").
        addValidator(new ExpectTextValidator("A Repository Exception occured."))      
    ) ; 
    addWebUnit(
        new SubmitFormUnit("SaveSearchByXPath", "Save result search by Query language  xpath").
        setFormId("UIJCRAdvancedSearch").  
        setField("name","SearchByXPath").
        setField("select","xpath").
        setField("query","/jcr:root/cms//*").
        setField("op","save").
        addValidator(new ExpectTextValidator("The query has been added"))      
    ) ;  
    addWebUnit(
        new ClickURLLinkUnit("CheckStatusSavedXpath", "Click on  Save Queries button to check status of action save search result by Query language  xpath").
        setURL("uicomponent=UISearch&op=selectNode&objectId=UIQueryList").                 
        addValidator(new ExpectTextValidator("/jcr:root/cms//*")).
        addValidator(new ExpectLinkWithURLValidator("uicomponent=UIQueryList&op=execute&objectId=/home/users/#{client.name}/queries/SearchByXPath"))
    ) ; 
    addWebUnit(
        new ClickURLLinkUnit("CheckResultSavedXpath", "Click on  Save Queries button to check result of action save search result by Query language  xpath").
        setURL("uicomponent=UIQueryList&op=execute&objectId=/home/users/#{client.name}/queries/SearchByXPath").                 
        addValidator(new ExpectLinkWithURLValidator("&uicomponent=UISearch&op=selectNode&objectId=UIJCRAdvancedSearch")).
        addValidator(new ExpectTextValidator("/cms"))
    ) ; 
    addWebUnit(
        new ClickURLLinkUnit("GoToSavedQueries", "Go to Saved queries to delete saved queries sql and xpath").
        setURL("uicomponent=UISearch&op=selectNode&objectId=UIQueryList").                 
        addValidator(new ExpectTextValidator("select * from nt:base where jcr:path like '/cms/%'")).
        addValidator(new ExpectTextValidator("/jcr:root/cms//*")).
        addValidator(new ExpectLinkWithURLValidator("uicomponent=UIQueryList&op=delete&objectId=/home/users/#{client.name}/queries/SearchBySQL")).
        addValidator(new ExpectLinkWithURLValidator("uicomponent=UIQueryList&op=delete&objectId=/home/users/#{client.name}/queries/SearchByXPath"))
    ) ; 
    COMMENT = "You can't delete saved queries ";
    addWebUnit(
      new TODO("Can'tDeleteSavedQueries", COMMENT).
      setComment(COMMENT).
      setStatus(WebUnit.STATUS_INCOMPLETE)
    ) ;
    addWebUnit(
        new ClickURLLinkUnit("DeleteSavedQuerySQL", "Delete saved query sql").
        setURL("uicomponent=UIQueryList&op=delete&objectId=/home/users/#{client.name}/queries/SearchBySQL").                 
        addValidator(new ExpectLinkWithURLValidator("uicomponent=UIQueryList&op=delete&objectId=/home/users/#{client.name}/queries/SearchBySQL",0)).
        addValidator(new ExpectNoTextValidator("SearchBySQL"))
    ) ;
    addWebUnit(
        new ClickURLLinkUnit("DeleteSavedQueryXpath", "Delete saved query xpath").
        setURL("uicomponent=UIQueryList&op=delete&objectId=/home/users/#{client.name}/queries/SearchByXPath").                 
        addValidator(new ExpectLinkWithURLValidator("uicomponent=UIQueryList&op=delete&objectId=/home/users/#{client.name}/queries/SearchByXPath",0)).
        addValidator(new ExpectNoTextValidator("SearchByXPath"))
    ) ; 
    addWebUnit(
        new ClickURLLinkUnit("SelectWorkspace", "click on select workspace icon").
        setURL("uicomponent=MainToolbar&op=selectWorkspace").                  
        addValidator(new ExpectLinkWithURLValidator("uicomponent=UIWorkspaceBrowser&op=selectWorkspace&objectId=draft"))      
    ) ;
  }                 
  public java.util.List getRequiredSuites() {    
    String[] roles = ["user"] ;
    return [new NewAccountSuite(), new UserLoginSuite("#{client.name}", "#{client.name}", roles)] ;
  }  
}