/**************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved. *
 * Please look at license.txt in info directory for more license detail.  *
 **************************************************************************/
package suites.portal;

import condition.* ;
import suites.share.* ;

import org.exoplatform.test.*;
import org.exoplatform.test.web.*;
import org.exoplatform.test.web.unit.*;
import org.exoplatform.test.web.validator.*;

import suites.admin.*;

/**
 * Created by The eXo Platform SARL
 * Author : Hoa  Pham
 *          hoapham@exoplatform.com,phamvuxuanhoa@yahoo.com
 * Nov 8, 2005
 */
public class CustomizationPageSuite extends WebUnitSuite {
  String COMMENT  = "You must run PortletRegistrySuite before run this suite";
  public CustomizationPageSuite() {
    super("CutomizePageSuite", "Add and edit in the Page") ;    
    addWebUnit(CommonUnit.CLICK_EDIT_PAGE_MODE) ;
    addWebUnit(CommonUnit.CLICK_BROWSE_PAGES) ;
    addWebSuite(new PageBrowseSuite());
    //Browse Page
    //-----Click on Browse Page
    addWebUnit(
      new ClickURLLinkUnit("ClickOnBrowsePage", "Tell web client click on BrowsePage button").
      setURL("&uicomponent=UIToolbarPage&op=browsePage").
      addValidator(new ExpectLinkWithURLValidator("uicomponent=UIPageList&op=delete&objectId=#{client.name}:testPage"))      
    ) ;                    
    //-----Delete testPage
    addWebUnit(
      new ClickURLLinkUnit("DeletetestPage", "Tell web client delete created testPage").
      setURL("uicomponent=UIPageList&op=delete&objectId=#{client.name}:testPage").
      addValidator(new ExpectTextValidator("The page has been deleted successfully"))
    ) ;
    addWebUnit(
      new ClickURLLinkUnit("SavePage", "Click on Save Page button").
      setURL("&uicomponent=UIToolbarPage&op=savePage")
    ) ;
    addWebUnit(
      new ClickURLLinkUnit("Back", "Click on back button").
      setURL("uicomponent=UIToolbar&op=return")
    ) ;
    
    //-----Back to view page-------------    
    addWebUnit(CommonUnit.CLICK_VIEW_MODE) ;      
    addWebUnit(CommonUnit.CLICK_EDIT_PAGE_MODE) ;
    //---Add UserInforPortlet in home page--
    addWebUnit(
        new ClickURLLinkUnit("AddPortlet(onPage)", "tell web client click'addPortlet' on page").
        setURL("componentId=page&portal:action=addPortlet")        
    ) ;
    addWebSuite(new AddPortletSuite("user","UserInfo")) ;
    addWebUnit(CommonUnit.CLICK_SAVE_PAGE) ;
    //-----Back to view page-------------    
    addWebUnit(CommonUnit.CLICK_VIEW_MODE) ;
    //----Edit profile Information------
    addWebSuite(new EditUserProfileSuite("#{client.name}")) ;
    addWebSuite(new UserLogoutSuite()) ;
    
    //----login as admin to view all profile infomation is updated    
    addWebSuite(new UserLoginSuite()) ;
    goToPage("/Site Map/Management") ;
    
    addWebUnit(
        new ClickURLLinkUnit("GoToUserTab", "Click on the groups tab").
        setURL("uicomponent=organization-portlet&op=selectNode&objectId=usernode").              
        addValidator(new ExpectLinkWithURLValidator("op=viewProfile&objectId=#{client.name}"))
      ) ;    
    addWebUnit(
        new ClickURLLinkUnit("ClickViewUserProfile", "Click the view user profile icon").
        setURL("op=viewProfile&objectId=#{client.name}").
        addValidator(new ExpectTextValidator("Info")).
        addValidator(new ExpectTextValidator("#{client.name}")).
        addValidator(new ExpectTextValidator("fn")).
        addValidator(new ExpectTextValidator("p@exo.com")).
        addValidator(new ExpectTextValidator("www.p.com")).
        //----business information
        addValidator(new ExpectTextValidator("084")).
        addValidator(new ExpectTextValidator("b@exo.com")).
        addValidator(new ExpectTextValidator("Country")).
        addValidator(new ExpectTextValidator("www.eXo.com"))   
      ) ;    
    addWebUnit(
        new ClickLinkWithText("ClickBackLink", "Go back to the user list screen").
        setTextLink("back")
    ) ;
    addWebSuite(new UserLogoutSuite()) ;
    String[] roles = ["user"] ;
    addWebSuite(new UserLoginSuite("#{client.name}", "#{client.name}", roles)) ;  
    
    
  }
  public java.util.List getRequiredSuites() {     
    String[] roles = ["user"] ;
    return [new NewAccountSuite(), new UserLoginSuite("#{client.name}", "#{client.name}", roles)] ;  
  } 
}
