/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package suites.portal;

import condition.* ;
import suites.share.* ;
import org.exoplatform.test.web.*;
import org.exoplatform.test.web.unit.*;
import org.exoplatform.test.web.validator.*;
import org.exoplatform.test.portlet.Login.*;

/**
 * This suite does:
 *    1)Go to browse page and delete if existed newpage
 *    2)Add a new page
 *    3)Add portlet to page
 *    4)Save action add newpage
 *    5)Go to list page
 *    
 * Created by The eXo Platform SARL
 * Author : Hoa  Nguyen Thi
 *          hoa2501@yahoo.com
 * Mar 23, 2006
 */
public class EditNavPortletSuite extends WebUnitSuite {
  String COMMENT="You must run PortletRegistrySuite suite before you run this suite";
//  public EditNavPortletSuite(String username,String namePage,boolean isShowInfoBar,boolean isShowPortletMode,
//      boolean isShowWindowState,String editPrefPermission,String LinkValidator,int isLinkValidator) {
    public EditNavPortletSuite(String username,String namePage,String editPrefPermission,String LinkValidator,int isLinkValidator) {
    super("EditNavPortletSuite", "Edit navigation portlet ") ;
    addWebUnit(
        new ClickURLLinkUnit("SelectPageEdit", "Select page need edit").
        setURL("uicomponent=UIPageList&op=preview&objectId=${username}:${namePage}").
        addValidator(new ExpectLinkWithURLValidator("uicomponent=UIPagePreviewToolbar&op=edit"))
    ) ;
    addWebUnit(
        new ClickURLLinkUnit("ClickEditIcon", "Click on edit icon to edit some properties of page").
        setURL("uicomponent=UIPagePreviewToolbar&op=edit").
        addValidator(new ExpectLinkWithURLValidator("portal:componentId=page&portal:action=editProperty"))
    ) ;
    addWebUnit(
        new ClickURLLinkUnit("ClickPortletEdit", "Select Portlet need edit").
        setURL("${username}?portal:componentId=NavigationPortlet&portal:action=editProperty").
        addValidator(new ExpectFormIdValidator("portletForm"))
    ) ;
    addWebUnit(
        new SubmitFormUnit("EditPortlet", "Fill portlet's information and click save").
        setFormId("portletForm").
//        setCheckBox("showInfoBar",isShowInfoBar).
//        setCheckBox("showPortletMode",isShowPortletMode).
//        setCheckBox("showWindowState",isShowWindowState).
        setField("editPrefPermission",editPrefPermission).
        setField("op", "save").
        addValidator(new ExpectLinkWithURLValidator(LinkValidator,isLinkValidator)) 
    );
    addWebUnit(
        new ClickURLLinkUnit("SaveActionEditPortlet", "Save action with edit portlet").
        setURL("uicomponent=UIPagePreviewToolbar&op=save").
        addValidator(new ExpectLinkWithURLValidator("${username}?uicomponent=UIPagePreviewToolbar&op=PhaseId[1].cancel"))
    ) ;
    addWebUnit(
        new ClickURLLinkUnit("ClickOnCancel", "Click on cancel icon").
        setURL("${username}?uicomponent=UIPagePreviewToolbar&op=PhaseId[1].cancel").
        addValidator(new ExpectFormIdValidator("searchForm"))
    ) ;  
  }
}