/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package suites.share ;

import condition.* ;
import org.exoplatform.test.web.*;
import org.exoplatform.test.web.unit.*;
import org.exoplatform.test.web.validator.*;

/**
 * Created by The eXo Platform SARL
 * Author : Hoa  Pham
 *          hoapham@exoplatform.com,phamvuxuanhoa@yahoo.com
 * Nov 8, 2005
 */
public class EditUserProfileSuite extends WebUnitSuite {
  public EditUserProfileSuite(String username) {
    super("EditUserProfileSuite", "Edit User profile information on 'UserInfo' portlet") ;    
    //----Click 'Profile Summary' tab to view profile sumary------------
    addWebUnit(
        new ClickURLLinkUnit("ClickProfileSummaryTab", "Tell web client click 'ProfileSummary' tab").
        setURL("op=selectNode&objectId=UIUserProfileSummary").
        addValidator(new ExpectTextValidator("Viewing User Profile")).
        addValidator(new ExpectTextValidator("User Home Info")).
        addValidator(new ExpectTextValidator("User Business Info"))
    ) ;    
    addWebUnit(
        new ClickURLLinkUnit("ClickAdminTab", "Tell web client click 'Admin' tab").
        setURL("op=selectNode&objectId=UIUserProfileAdmin").
        addValidator(new ExpectLinkWithURLValidator("op=selectNode&objectId=UIPersonalInfoForm")).
        addValidator(new ExpectLinkWithURLValidator("op=selectNode&objectId=UIBusinessInfoForm")).
        addValidator(new ExpectLinkWithURLValidator("op=selectNode&objectId=UIAccountForm")).
        addValidator(new ExpectLinkWithURLValidator("op=selectNode&objectId=UIOtherInfoForm"))
    ) ;
    //----Edit personal infomation
    addWebUnit(
        new ClickURLLinkUnit("ClickPersonalInfoTab", "Tell web client click 'PersonalInfo' tab").
        setURL("op=selectNode&objectId=UIPersonalInfoForm").
        addValidator(new ExpectFormIdValidator("UIPersonalInfoForm"))
    ) ;    
    addWebUnit(
        new SubmitFormUnit("UpdatePersonalInfomation", "submit the PersonalInfoForm with the new property values").
        setFormId("UIPersonalInfoForm").
        setField("given", "${username}").
        setField("family", "fn").
        setField("home_online_email", "p@exo.com").
        setField("home_online_uri", "www.p.com").
        setField("op" ,"save").
        addValidator(new ExpectTextValidator("User's personal and home informations saved"))
    );    
    //----Edit business infomation
    addWebUnit(
        new ClickURLLinkUnit("ClickPersonalInfoTab", "Tell web client click 'PersonalInfo' tab").
        setURL("op=selectNode&objectId=UIBusinessInfoForm").
        addValidator(new ExpectFormIdValidator("UIBusinessInfoForm"))
    ) ;    
    addWebUnit(
        new SubmitFormUnit("UpdateBusinessInfomation", "submit the PersonalInfoForm with the new property values").
        setFormId("UIBusinessInfoForm").
        setField("business_postal_name", "084").
        setField("business_online_email", "b@exo.com").
        setField("business_postal_country", "Country").
        setField("business_online_uri", "www.eXo.com").
        setField("op" ,"save").
        addValidator(new ExpectTextValidator("User's business informations saved"))
    );
    
    //  ----Edit Account infomation
    addWebUnit(
        new ClickURLLinkUnit("ClickAccountInfoTab", "Tell web client click 'AccountInfo' tab").
        setURL("op=selectNode&objectId=UIAccountForm").
        addValidator(new ExpectFormIdValidator("accountForm"))
    ) ;    
    addWebUnit(
        new SubmitFormUnit("UpdateAccountInfomation", "submit the AccountInfoForm with the new property values").
        setFormId("accountForm").
        setField("firstname", "Name").
        setField("lastname", "LName").
        setField("email", "eXo@sf.net").
        setField("op" ,"save").
        addValidator(new ExpectTextValidator("The user account has been updated"))
    );    
    //----Edit Other infomation
    addWebUnit(
        new ClickURLLinkUnit("ClickOtherInfoTab", "Tell web client click 'OtherInfo' tab").
        setURL("op=selectNode&objectId=UIOtherInfoForm").
        addValidator(new ExpectFormIdValidator("UIOtherInfoForm"))
    ) ;    
    addWebUnit(
        new SubmitFormUnit("UpdateOtherInfomation", "submit the OtherInfoForm with the new property values").
        setFormId("UIOtherInfoForm").
        setField("other_avatar_url", "myavatar").
        setField("other_signature", "&{username}Sign").        
        setField("op" ,"save").
        addValidator(new ExpectTextValidator("User's other informations saved"))
    );
    //----- click Profile Sumary to view all information is updated    
    addWebUnit(
        new ClickURLLinkUnit("ClickProfileSummaryTab", "Tell web client click 'ProfileSummary' tab").
        setURL("op=selectNode&objectId=UIUserProfileSummary").
        //-----personal information
        addValidator(new ExpectTextValidator("${username}")).
        addValidator(new ExpectTextValidator("fn")).
        addValidator(new ExpectTextValidator("p@exo.com")).
        addValidator(new ExpectTextValidator("www.p.com")).
        //----business information
        addValidator(new ExpectTextValidator("084")).
        addValidator(new ExpectTextValidator("b@exo.com")).
        addValidator(new ExpectTextValidator("Country")).
        addValidator(new ExpectTextValidator("www.eXo.com"))                
    ) ;    
  }
}